local colorShot = {}

colorShot.time = GAMEPLAY.GET_GAME_TIMER()

--// local variables
local tTimer = 100 -- default number of ticks to display the initial message
local tToShow = "" -- the initial message...
local toggle_switch=1
local availColors = {[0]=75,75,75,20,5,1}
local allColors = {[0]={{0,"Black"},{1,"Carbon Black"},{2,"Graphite"},{3,"Anthracite Black"},{4,"Black Steel"},{5,"Dark Steel"},{6,"Silver"},{7,"Bluish Silver"},{8,"Rolled Steel"},{9,"Shadow Silver"},{10,"Stone Silver"},{11,"Midnight Silver"},{12,"Cast Iron Silver"},{13,"Red"},{14,"Torino Red"},{15,"Formula Red"},{16,"Lava Red"},{17,"Blaze Red"},{18,"Grace Red"},{19,"Garnet Red"},{20,"Sunset Red"},{21,"Cabernet Red"},{22,"Wine Red"},{23,"Candy Red"},{24,"Hot Pink"},{25,"Pfister Pink"},{26,"Salmon Pink"},{27,"Sunrise Orange"},{28,"Orange"},{29,"Bright Orange"},{30,"Gold"},{31,"Bronze"},{32,"Yellow"},{33,"Race Yellow"},{34,"Dew Yellow"},{35,"Dark Green"},{36,"Racing Green"},{37,"Sea Green"},{38,"Olive Green"},{39,"Bright Green"},{40,"Gasoline Green"},{41,"Lime Green"},{42,"Midnight Blue"},{43,"Galaxy Blue"},{44,"Dark Blue"},{45,"Saxon Blue"},{46,"Blue"},{47,"Mariner Blue"},{48,"Harbor Blue"},{49,"Diamond Blue"},{50,"Surf Blue"},{51,"Nautical Blue"},{52,"Racing Blue"},{53,"Ultra Blue"},{54,"Light Blue"},{55,"Chocolate Brown"},{56,"Bison Brown"},{57,"Creek Brown"},{58,"Feltzer Brown"},{59,"Maple Brown"},{60,"Beechwood Brown"},{61,"Sienna Brown"},{62,"Saddle Brown"},{63,"Moss Brown"},{64,"Woodbeech Brown"},{65,"Straw Brown"},{66,"Sandy Brown"},{67,"Bleached Brown"},{68,"Schafter Purple"},{69,"Spinnaker Purple"},{70,"Midnight Purple"},{71,"Bright Purple"},{72,"Cream"},{73,"Ice White"},{74,"Frost White"}},
{{0,"Black"},{1,"Carbon Black"},{2,"Graphite"},{3,"Anthracite Black"},{4,"Black Steel"},{5,"Dark Steel"},{6,"Silver"},{7,"Bluish Silver"},{8,"Rolled Steel"},{9,"Shadow Silver"},{10,"Stone Silver"},{11,"Midnight Silver"},{12,"Cast Iron Silver"},{13,"Red"},{14,"Torino Red"},{15,"Formula Red"},{16,"Lava Red"},{17,"Blaze Red"},{18,"Grace Red"},{19,"Garnet Red"},{20,"Sunset Red"},{21,"Cabernet Red"},{22,"Wine Red"},{23,"Candy Red"},{24,"Hot Pink"},{25,"Pfister Pink"},{26,"Salmon Pink"},{27,"Sunrise Orange"},{28,"Orange"},{29,"Bright Orange"},{30,"Gold"},{31,"Bronze"},{32,"Yellow"},{33,"Race Yellow"},{34,"Dew Yellow"},{35,"Dark Green"},{36,"Racing Green"},{37,"Sea Green"},{38,"Olive Green"},{39,"Bright Green"},{40,"Gasoline Green"},{41,"Lime Green"},{42,"Midnight Blue"},{43,"Galaxy Blue"},{44,"Dark Blue"},{45,"Saxon Blue"},{46,"Blue"},{47,"Mariner Blue"},{48,"Harbor Blue"},{49,"Diamond Blue"},{50,"Surf Blue"},{51,"Nautical Blue"},{52,"Racing Blue"},{53,"Ultra Blue"},{54,"Light Blue"},{55,"Chocolate Brown"},{56,"Bison Brown"},{57,"Creek Brown"},{58,"Feltzer Brown"},{59,"Maple Brown"},{60,"Beechwood Brown"},{61,"Sienna Brown"},{62,"Saddle Brown"},{63,"Moss Brown"},{64,"Woodbeech Brown"},{65,"Straw Brown"},{66,"Sandy Brown"},{67,"Bleached Brown"},{68,"Schafter Purple"},{69,"Spinnaker Purple"},{70,"Midnight Purple"},{71,"Bright Purple"},{72,"Cream"},{73,"Ice White"},{74,"Frost White"}},
{{0,"Black"},{1,"Carbon Black"},{2,"Graphite"},{3,"Anthracite Black"},{4,"Black Steel"},{5,"Dark Steel"},{6,"Silver"},{7,"Bluish Silver"},{8,"Rolled Steel"},{9,"Shadow Silver"},{10,"Stone Silver"},{11,"Midnight Silver"},{12,"Cast Iron Silver"},{13,"Red"},{14,"Torino Red"},{15,"Formula Red"},{16,"Lava Red"},{17,"Blaze Red"},{18,"Grace Red"},{19,"Garnet Red"},{20,"Sunset Red"},{21,"Cabernet Red"},{22,"Wine Red"},{23,"Candy Red"},{24,"Hot Pink"},{25,"Pfister Pink"},{26,"Salmon Pink"},{27,"Sunrise Orange"},{28,"Orange"},{29,"Bright Orange"},{30,"Gold"},{31,"Bronze"},{32,"Yellow"},{33,"Race Yellow"},{34,"Dew Yellow"},{35,"Dark Green"},{36,"Racing Green"},{37,"Sea Green"},{38,"Olive Green"},{39,"Bright Green"},{40,"Gasoline Green"},{41,"Lime Green"},{42,"Midnight Blue"},{43,"Galaxy Blue"},{44,"Dark Blue"},{45,"Saxon Blue"},{46,"Blue"},{47,"Mariner Blue"},{48,"Harbor Blue"},{49,"Diamond Blue"},{50,"Surf Blue"},{51,"Nautical Blue"},{52,"Racing Blue"},{53,"Ultra Blue"},{54,"Light Blue"},{55,"Chocolate Brown"},{56,"Bison Brown"},{57,"Creek Brown"},{58,"Feltzer Brown"},{59,"Maple Brown"},{60,"Beechwood Brown"},{61,"Sienna Brown"},{62,"Saddle Brown"},{63,"Moss Brown"},{64,"Woodbeech Brown"},{65,"Straw Brown"},{66,"Sandy Brown"},{67,"Bleached Brown"},{68,"Schafter Purple"},{69,"Spinnaker Purple"},{70,"Midnight Purple"},{71,"Bright Purple"},{72,"Cream"},{73,"Ice White"},{74,"Frost White"}},
{{0,"Matte Black"},{1,"Matte Gray"},{2,"Matte Light Gray"},{3,"Matte Ice White"},{4,"Matte Blue"},{5,"Matte Dark Blue"},{6,"Matte Midnight Blue"},{7,"Matte Midnight Purple"},{8,"Matte Schafter Purple"},{9,"Matte Red"},{10,"Matte Dark Red"},{11,"Matte Orange"},{12,"Matte Yellow"},{13,"Matte Lime Green"},{14,"Matte Green"},{15,"Matte Forest Green"},{16,"Matte Foliage Green"},{17,"Matte Olive Drab"},{18,"Matte Dark Earth"},{19,"Matte Desert Tan"}},
{{0,"Brushed Steel"},{1,"Brushed Black Steel"},{2,"Brushed Aluminum"},{3,"Pure Gold"},{4,"Brushed Gold"}},
{{0,"Chrome"}}}
local smokeColors = {black	={8,8,8,"Black"}, 
					grey	={90,94,102,"Silver"}, 
					white	={255,255,255,"White"}, 
					red		={138,11,0,"Midnight Red"}, 
					yellow	={217,166,0,"Race Yellow"}, 
					green	={0,56,5,"Bright Green"}, 
					blue	={0,85,196,"Ultra Blue"}, 
					midnight={0,1,8,"Midnight Blue"}, 
					orange	={128,40,0,"Sunrise Orange"}, 
					purple	={50,6,66,"Bright Purple"},
					pink	={255,0,160,"Hot Pink"},
					patriot	={0,0,0,"Patriotic"}
}
local carColors = {	black	={{0,1,1,"Black"},				{111,112,0, "Ice White"}},
					pink	={{135,71,0,"Hot Pink"}, 		{0,135,0,"Midnight Pink"}},	
					silver	={{4,111,0,"Silver"},			{120,120,0,"Chrome"}},
					red		={{29,28,0,"Fire Engine Red"},	{0,29,1,"Wine Red"}},
					orange	={{36,89,5,"Sunrise Orange"},	{34,89,1,"Sunrise Cabernet"}},
					yellow	={{89,89,1,"Race Yellow"},		{0,160,1,"Black Gold"}},
					green	={{53,89,0,"Bright Green"},		{0,53,1,"Midnight Green"}},
					blue	={{73,70,2,"Ultra Blue"},		{0,73,1,"Midnight Blue"}},
					purple	={{71,145,1,"Schafter Purple"},	{0,71,1,"Midnight Purple"}}
}
local secondaryColors = {	black={{1,0,"Black"},			{1,42,"Midnight Blue"}},
							white={{1,73,"Ice White"},		{1,24,"Hot Pink"}},
							silver={{1,7,"Bluish Silver"},	{5,0,"Chrome"}},
							red={{1,14,"Torino Red"},		{1,28,"Orange"}},
							yellow={{1,33,"Race Yellow"},	{4,4,"Gold"}},
							green={{1,39,"Bright Green"},	{1,35,"Dark Green"}},
							blue={{1,53,"Ultra Blue"},		{1,52,"Racing Blue"}},
							purple={{1,71,"Bright Purple"},	{1,70,"Midnight Purple"}}
}

--Thanks to szabo for this code!
local function showThisText(str)
	tTimer = 100 --resets the number of ticks for new messages
	tToShow = str
end

local function drawText()
	UI.SET_TEXT_FONT(1)
	UI.SET_TEXT_SCALE(0.6, 0.6)
	UI.SET_TEXT_COLOUR(255, 255, 255, 255)
	UI.SET_TEXT_WRAP(0, 1)
	UI.SET_TEXT_CENTRE(false)
	UI.SET_TEXT_DROPSHADOW(20, 20, 0, 0, 0)
	UI.SET_TEXT_EDGE(5, 0, 0, 0, 255)
	UI._SET_TEXT_ENTRY("STRING")
	UI._ADD_TEXT_COMPONENT_STRING(tToShow)
	UI._DRAW_TEXT(0, 0)
	tTimer = tTimer-1 --counts down X number of ticks
end

local function repairtheCar(theCar)
	--Fix visible damage
		VEHICLE.SET_VEHICLE_FIXED(theCar)
	--Did the VEHICLE get trashed or did the engine die? Lets fix that...
		VEHICLE.IS_VEHICLE_DRIVEABLE(theCar, true)
		VEHICLE.SET_VEHICLE_ENGINE_ON(theCar, true, true)
	--Clean the car - dirtLvl = 0 (clean) to 15 (dirty)
		VEHICLE.SET_VEHICLE_DIRT_LEVEL(theCar, 0)
	--Lets make our car "not wanted" or "stolen" anymore as well
		VEHICLE.SET_VEHICLE_IS_WANTED(theCar, false)
		VEHICLE.SET_VEHICLE_IS_STOLEN(theCar, false)
	-- Some experimental stuff
		VEHICLE.SET_VEHICLE_HAS_BEEN_OWNED_BY_PLAYER(theCar, true) -- Experimental
		VEHICLE.SET_PLAYERS_LAST_VEHICLE(theCar) -- Experimental
end

local function setPrimaryColor(theCar,color,smoke)
	VEHICLE.SET_VEHICLE_MOD_KIT(theCar, 0)
	VEHICLE.CLEAR_VEHICLE_CUSTOM_PRIMARY_COLOUR(theCar)
	VEHICLE.CLEAR_VEHICLE_CUSTOM_SECONDARY_COLOUR(theCar)
	if((GAMEPLAY.GET_GAME_TIMER() - colorShot.time)> 150) then
		local prime = carColors[color][toggle_switch][1]
		local pearl = carColors[color][toggle_switch][2]
		local plate = carColors[color][toggle_switch][3]
		local cName = carColors[color][toggle_switch][4]
		VEHICLE.SET_VEHICLE_COLOURS(theCar, prime, prime)	
	--License Plate
		VEHICLE.SET_VEHICLE_NUMBER_PLATE_TEXT_INDEX(theCar, plate)	
	--Rim Color (VEHICLE, pearl index paint color, wheel index paint color)
		VEHICLE.SET_VEHICLE_EXTRA_COLOURS(theCar, pearl, prime)
	--Tire Smoke
		VEHICLE.TOGGLE_VEHICLE_MOD(theCar, 20, true)
		VEHICLE.SET_VEHICLE_TYRE_SMOKE_COLOR(theCar, smokeColors[smoke][1],smokeColors[smoke][2],smokeColors[smoke][3])
	--Toggle Switch
		if toggle_switch == 1 then toggle_switch=toggle_switch+1 else toggle_switch=1 end
		text = cName.." Paint with "..smokeColors[smoke][4].." Smoke"
		showThisText(text)
		colorShot.time = GAMEPLAY.GET_GAME_TIMER()
	end
	--Repair/Clean VEHICLE
		repairtheCar(theCar)
end

local function setSecondary(theCar, color)
	-- Function to apply the secondary colors
	if((GAMEPLAY.GET_GAME_TIMER() - colorShot.time)> 150) then
		local pType = secondaryColors[color][toggle_switch][1]
		local paint = secondaryColors[color][toggle_switch][2]
		local pName = secondaryColors[color][toggle_switch][3]
		VEHICLE.CLEAR_VEHICLE_CUSTOM_SECONDARY_COLOUR(theCar)
		VEHICLE.SET_VEHICLE_MOD_COLOR_2(theCar, pType, paint)
	--Toggle Switch
		if toggle_switch == 1 then toggle_switch=toggle_switch+1 else toggle_switch=1 end
		colorShot.time = GAMEPLAY.GET_GAME_TIMER()
		text = pName.." secondary paint applied"
		showThisText(text)
	end
end

function randomColor(theCar)	
	if((GAMEPLAY.GET_GAME_TIMER() - colorShot.time)> 150) then
		local pType = math.random(0,5)
		local color = math.random(1,availColors[pType])
		local paint = allColors[pType][color][1]
		local pName = allColors[pType][color][2]
	
		VEHICLE.SET_VEHICLE_MOD_KIT(theCar, 0)
		VEHICLE.CLEAR_VEHICLE_CUSTOM_PRIMARY_COLOUR(theCar)
		VEHICLE.CLEAR_VEHICLE_CUSTOM_SECONDARY_COLOUR(theCar)
		
		VEHICLE.SET_VEHICLE_MOD_COLOR_1(theCar, pType, paint, pType)
		VEHICLE.SET_VEHICLE_MOD_COLOR_2(theCar, pType, paint)
		
		colorShot.time = GAMEPLAY.GET_GAME_TIMER()
		text = "Random Paint Color \""..pName.."\" Has Been Applied"
		showThisText(text)
	end
end

function colorShot.unload()
end

function colorShot.init()
end

function colorShot.tick()
	local playerPed = PLAYER.PLAYER_PED_ID()
	local theCar = PED.GET_VEHICLE_PED_IS_IN(playerPed, true)
	if (PED.IS_PED_IN_ANY_VEHICLE(playerPed, false)) then
	----------------------------------------------------------------------------------
	--								Primary Car Colors 								--
	-- 						Controls rim and smoke color as well. 					--
	----------------------------------------------------------------------------------
		if (get_key_pressed(Keys.NumPad1)) then	
		-- setPrimaryColor(the VEHICLE, the Primary Color, the Somke Color) 
		-- use the table at the top of the script for color choices, or to add your own
			setPrimaryColor(theCar,"black","black") --black & white
		end
		if (get_key_pressed(Keys.NumPad2)) then
			setPrimaryColor(theCar,"pink","pink") -- hot pink & midnight pink
		end
		if (get_key_pressed(Keys.NumPad3)) then
			setPrimaryColor(theCar,"silver","white") --silver & chrome 
		end
		if (get_key_pressed(Keys.NumPad4)) then
			setPrimaryColor(theCar,"red","red")	--red & midnight red
		end			
		if (get_key_pressed(Keys.NumPad5)) then
			setPrimaryColor(theCar,"orange","orange") --sunrise orange & sunrise cabernet
		end
		if (get_key_pressed(Keys.NumPad6)) then
			setPrimaryColor(theCar,"yellow","yellow") --yellow & black gold
		end
		if (get_key_pressed(Keys.NumPad7)) then
			setPrimaryColor(theCar,"green","green") --green & midnight green
		end
		if (get_key_pressed(Keys.NumPad8)) then			
			setPrimaryColor(theCar,"blue","blue") --blue & midnight blue
		end
		if (get_key_pressed(Keys.NumPad9)) then
			setPrimaryColor(theCar,"purple","purple") --purple & purple blue
		end
	----------------------------------------------------------------------------------
	--					Secondary Colors, Stripes, Details, etc 					--
	-- 																				--
	----------------------------------------------------------------------------------
		if (get_key_pressed(Keys.B)) then
			--fuction(the car, paint type, color code)
			setSecondary(theCar, "black") --black & midnight blue
		end
		if (get_key_pressed(Keys.N)) then
			setSecondary(theCar, "white") --white & pink
		end
		if (get_key_pressed(Keys.K)) then
			setSecondary(theCar, "silver") --silver & chrome 
		end
		if (get_key_pressed(Keys.J)) then
			setSecondary(theCar, "red") --yellow & gold
		end
		if (get_key_pressed(Keys.L)) then
			setSecondary(theCar, "yellow") --red & orange
		end
		if (get_key_pressed(Keys.I)) then
			setSecondary(theCar, "green") --green & dark green
		end
		if (get_key_pressed(Keys.O)) then
			setSecondary(theCar, "blue") --light blue & dark blue 
		end
		if (get_key_pressed(Keys.U)) then
			setSecondary(theCar, "purple") --purple & midnight purple
		end
	----------------------------------------------------------------------------------
	--								Random Color Generator 							--
	-- 			Applies a randomly generated primary color to the vehicle			--
	----------------------------------------------------------------------------------
		if (get_key_pressed(Keys.Add)) then
			randomColor(theCar)
		end
	end
	--//A little something to display any screen messages/text
	if (tTimer > 0) then
		drawText()
	end
end

return colorShot